--Swords demo by substitute541

function love.load()
	charging = false
	swords_damage = 0
	time_charging = 0

	player = {}
	player.x = math.random() * love.graphics.getWidth()
	player.y = math.random() * love.graphics.getHeight()
	player.sword_angle = 0
	player.angle = 0
	player.speed = 0
	player.vx = 0
	player.vy = 0
	player.health = 100
	player.maxHealth = 100

	enemy = {}
	enemy.x = math.random() * love.graphics.getWidth()
	enemy.y = math.random() * love.graphics.getHeight()
	enemy.damage = 10
	enemy.curTime = 0
	enemy.health = 100
	enemy.maxHealth = 100
	enemy.angle = 0
	enemy.vx = 0
	enemy.vy = 0

	curTime = 0
end

function love.keypressed(key)
	if key == "r" then
		love.load()
	end
end

function love.update(dt)
	curTime = curTime + dt

	--{{ Player Movement
	if love.keyboard.isDown("w") then
		player.speed = 200
	elseif love.keyboard.isDown("s") then
		player.speed = -200
	else
		player.speed = 0
	end
	if love.keyboard.isDown("a") then
		player.angle = player.angle - 5*dt
	elseif love.keyboard.isDown("d") then
		player.angle = player.angle + 5*dt
	end
	player.vx = math.cos(player.angle) * player.speed
	player.vy = math.sin(player.angle) * player.speed
	player.x = player.x + player.vx*dt
	player.y = player.y + player.vy*dt

	-- Sword swinging
	player.sword_angle = (love.mouse.getX() + love.graphics.getWidth()/2)/love.graphics.getWidth() * math.rad(140) + math.rad(360-140)
	
	-- Sword charging
	if love.mouse.isDown("l") then
		charging = true
	else
		charging = false
	end

	if charging then
		time_charging = time_charging + dt
		if time_charging < 5 then
			swords_damage = time_charging * 20
			if swords_damage > 50 then
				swords_damage = 50
			end
		elseif time_charging > 5 then
			swords_damage = swords_damage - 10*dt
			if swords_damage < 0 then
				swords_damage = 0
			end
		end

	else
		swords_damage = swords_damage - 100*dt
		if swords_damage < 0 then
			swords_damage = 0
		end
		time_charging = 0
	end

	-- Health regenerating
	player.health = player.health + 10*dt
	if player.health > player.maxHealth then
		player.health = player.maxHealth
	end

	--}}

	--{{ Enemy Movement
	if curTime > 1 then
		local dx = player.x - enemy.x
		local dy = player.y - enemy.y
		enemy.angle = math.atan2(dy, dx)
		curTime = 0
	end
	enemy.vx = math.cos(enemy.angle) * 150
	enemy.vy = math.sin(enemy.angle) * 150
	enemy.x = enemy.x + enemy.vx*dt
	enemy.y = enemy.y + enemy.vy*dt

	-- Enemy knockback when hit by sword
	local sword_tip = {}
	sword_tip.x = player.x+math.cos(player.angle+player.sword_angle)*60
	sword_tip.y = player.y+math.sin(player.angle+player.sword_angle)*60

	if swords_damage > 0 and (sword_tip.x - enemy.x)^2 + (sword_tip.y - enemy.y)^2 < 400 then
		enemy.x = enemy.x + math.cos(player.angle) * 70
		enemy.y = enemy.y + math.sin(player.angle) * 70
		enemy.health = enemy.health - swords_damage
	end

	enemy.health = enemy.health + 10*dt
	if enemy.health > enemy.maxHealth then
		enemy.health = enemy.maxHealth
	end

	--}}
end

function love.draw()
	--{{ Drawing the Player
	love.graphics.setColor(0, 255, 0)
	love.graphics.circle("fill", player.x, player.y, 20)

	-- Sword
	love.graphics.setColor(255, (1-swords_damage/50)*255, (1-swords_damage/50)*255)
	love.graphics.setLine((swords_damage/50)*3 + 3)
	love.graphics.line(player.x + math.cos(player.sword_angle+player.angle) * 20, player.y + math.sin(player.sword_angle+player.angle) * 20, player.x + math.cos(player.sword_angle+player.angle) * 60, player.y + math.sin(player.sword_angle+player.angle) * 60)
	
	-- Direction
	love.graphics.setLine(1)
	love.graphics.line(player.x, player.y, player.x + math.cos(player.angle)*40, player.y + math.sin(player.angle)*40)

	-- Health Bar
	love.graphics.setColor((1-player.health/player.maxHealth)*255, player.health/player.maxHealth*255, 0)
	love.graphics.rectangle("fill", player.x - 30, player.y - 35, player.health/player.maxHealth * 60, 5)

	--}}

	--{{ Drawing the Enemy
	love.graphics.setColor(255, 0, 0)
	love.graphics.circle("fill", enemy.x, enemy.y, 20)

	-- Health Bar
	love.graphics.setColor((1-enemy.health/enemy.maxHealth)*255, enemy.health/enemy.maxHealth*255, 0)
	love.graphics.rectangle("fill", enemy.x - 30, enemy.y - 35, enemy.health/enemy.maxHealth * 60, 5)
	--}}
end
